library ieee;
use ieee.std_logic_1164.all;

entity rep_2519 is
    Port ( 	
		oe_wi   : in std_logic;
		oe_yi   : in std_logic;
		pol_wi	: in std_logic;
		clr	: in std_logic;
		cp	: in std_logic;
		e	: in std_logic;

		wi 	: out std_logic_vector(3 downto 0 );
		yi 	: out std_logic_vector(3 downto 0 );

		di      : in std_logic_vector(3 downto 0 )


		 );


attribute LOC: string;
attribute LOC of  oe_wi:	signal is "P7";
attribute LOC of  oe_yi:	signal is "P8";
attribute LOC of  cp:		signal is "P1";
attribute LOC of  clr:		signal is "P3";
attribute LOC of  pol_wi:		signal is "P22";
attribute LOC of  e:		signal is "P4";
attribute LOC of yi:		signal is "P18 P15 P14 P21";
attribute LOC of wi:		signal is "P19 P16 P20 P23";

attribute LOC of di:		signal is "P6 P17 P5 P2";





end rep_2519;




architecture Behavioral of rep_2519 is

signal rg : std_logic_vector(3 downto 0 );

begin


-- ----------------------------------------------------------------------------------------

process( cp, clr ) 
begin

if ( clr = '0' ) then
 rg <= "0000";
else

	if ( rising_edge( cp )) then
		if ( E = '0' ) then
			rg <= di;
		end if;
	end if;

end if;

end process;

-- ----------------------------------------------------------------------------------------

process( oe_wi, pol_wi, rg ) 
begin

	if ( oe_wi = '0' ) then
		wi(0) <= rg(0) XOR pol_wi;
		wi(1) <= rg(1) XOR pol_wi;
		wi(2) <= rg(2) XOR pol_wi;
		wi(3) <= rg(3) XOR pol_wi;
	else
		wi <= "ZZZZ";
	end if;

end process;

-- ----------------------------------------------------------------------------------------

process(  oe_yi, rg  ) 
begin

	if ( oe_yi = '0' ) then
		yi <= rg;
	else
		yi <= "ZZZZ";
	end if;

end process;


-- ----------------------------------------------------------------------------------------



end Behavioral;




